﻿
function setKkPagger(pageIndex, totalPage, totalRecords, hrefFormer, hrefLatter, callback) {

    kkpager.generPageHtml({
        pno: pageIndex,
        //总页码
        total: totalPage,
        //总数据条数
        totalRecords: totalRecords,

        isShowTotalPage: false, //是否显示总页数
        isShowCurrPage: false,//是否显示当前页
        isShowTotalRecords: false, //是否显示总记录数
        isGoPage: false,    //是否显示页码跳转输入框
        isWrapedPageBtns: false,    //是否用span包裹住页码按钮
        isWrapedInfoTextAndGoPageBtn: false, //是否用span包裹住分页信息和跳转按钮

        //链接前部
        hrefFormer: hrefFormer,
        //链接尾部
        hrefLatter: hrefLatter,
        mode: 'click',
        click: function (n) {
            callback(n);
            this.selectPage(n);
        },
        lang: {
            firstPageText: '首页',
            firstPageTipText: '首页',
            lastPageText: '尾页',
            lastPageTipText: '尾页',
            prePageText: '上一页',
            prePageTipText: '上一页',
            nextPageText: '下一页',
            nextPageTipText: '下一页',

        }
    }, true);
}
function loadData(url, params, sucessCallBack) {
    $.ajax({
        url: url,
        asyn: false,
        type: "POST",
        data: params,
        success: function (data) {
            if (sucessCallBack) {
                sucessCallBack(data.data);
            }
        },
        error: function (data) {
            window.location.href = "/home/error/?message=数据加载失败，请稍后再试";
        }
    });
}
function postAction(url, params, sucessCallBack) {
    $.ajax({
        url: url,
        aysn: true,
        type: "POST",
        data: params,
        success: function (data) {
            if (sucessCallBack) {
                sucessCallBack(data);
            }
        },
        error: function () {

        }
    });
}

function postActionSync(url, params, sucessCallBack) {
    $.ajax({
        url: url,
        aysn: false,
        type: "POST",
        data: params,
        success: function (data) {
            if (sucessCallBack) {
                sucessCallBack(data);
            }
        },
        error: function () {

        }
    });
}

function dataTmplBind(data, templateScriptElement, containerElement, isAppend) {
    var f = templateScriptElement.text(),
        e = doT.template(f),
        u = e(data, undefined);
    isAppend
        ? $(containerElement).html($(containerElement).html() + u)
        : $(containerElement).html(u);
}

function dataTmplBindTop(data, templateScriptElement, containerElement, isAppend) {
    var f = templateScriptElement.text(),
        e = doT.template(f),
        u = e(data, undefined);
    isAppend
        ? $(containerElement).html(u + $(containerElement).html())
        : $(containerElement).html(u);
}

function selectedCheckBox(chk, box) {
    $(chk).select("");
    var tempCheckBox = document.getElementById(id);

    var status = tempCheckBox.checked;

    var arr = document.getElementById("div1").getElementsByTagName("input");
    for (var i = 0; i < arr.length; i++) {
        arr[i].checked = false;
    }

    if (status) {
        tempCheckBox.checked = true;
        $("#selectUserId").val(id)
    }
    else {
        $("#selectUserId").val("");
    }
}
function CheckBoxObject(id, chkAllId, itemIdName) {
    this._chkAllId = "chkAll";
    this._itemIdName = "itemid";
    if (chkAllId) {
        this._chkAllId = chkAllId;
    }
    if (itemIdName) {
        this._itemIdName = itemIdName;
    }
    this._objectId = "#" + id;
    this._inputCheckedSelect = this._objectId + " input:checked";
    this._inputCheckBoxSelect = this._objectId + " input:checkbox";
    this.getSelectCheckedCount = function () {
        var count = 0;
        var chkAll = this._chkAllId;
        $(this._inputCheckedSelect).map(function (i) {
            if (this.id != chkAll) {
                count++;
            }
        });
        return count;
    };
    this.getSelectedItmes = function () {
        var items = "";
        var chkAll = this._chkAllId;
        var itemName = this._itemIdName;
        $(this._inputCheckedSelect).map(function (i) {
            if (this.id != chkAll) {
                items += $(this).attr(itemName) + ",";
            }
        });
        if (items.length > 0) {
            items = items.substr(0, items.length - 1);
        }
        return items;
    };
    this.selectedAll = function () {
        var chkAll = this._chkAllId;
        var checked = $(this._objectId).find("#" + this._chkAllId).attr("checked") ? true : false;
        $(this.inputCheckBoxSelect).map(function (i) {
            if (this.id != chkAll) {
                $(this).attr("checked", checked);
            }
        });
    };
    this.checkBoxCount = function () {
        return $(this._inputCheckBoxSelect).length;
    };
    this.setSelectedAll = function () {
        var total = this.checkBoxCount();
        var selectedCount = this.getSelectCheckedCount();
        $(this._objectId).find("#" + this._chkAllId).attr("checked", selectedCount == (total - 1));
    };
}